/*
 16 character 2 line I2C Display
 Backpack Interface labelled "YwRobot Arduino LCM1602 IIC V1"
 */
 
int OP1 = 2;
int OP2 = 3;

int OP3 = 6;
int OP4 = 7;

/*-----( Import needed libraries )-----*/
#include <Wire.h>  // Comes with Arduino IDE
// Get the LCD I2C Library here: 
// https://bitbucket.org/fmalpartida/new-liquidcrystal/downloads
// Move any other LCD libraries to another folder or delete them
// See Library "Docs" folder for possible commands etc.
#include <LiquidCrystal_I2C.h>

/*-----( Declare Constants )-----*/
/*-----( Declare objects )-----*/
// set the LCD address to 0x27 for a 20 chars 4 line display
// Set the pins on the I2C chip used for LCD connections:
//                    addr, en,rw,rs,d4,d5,d6,d7,bl,blpol
LiquidCrystal_I2C lcd(0x27, 2, 1, 0, 4, 5, 6, 7, 3, POSITIVE);  // Set the LCD I2C address
 
extern "C"{
	#include "DS1302.h"
        #include "XPORT_linker.h"
        #include "Timer.h"
} 

String inputString = "";         // a string to hold incoming data
boolean stringComplete = false;  // whether the string is complete
word Timer_Display = 0;

word counter_read;
char RecieveString[100];

int cnt = 0;

void setup()
{
  // put your setup code here, to run once:
  
            pinMode(OP1,    OUTPUT);
            pinMode(OP2,    OUTPUT);
            pinMode(A0,     OUTPUT);      // sets the A0 pin as output TCP Module RESET
            
            pinMode(OP3,    OUTPUT);
            pinMode(OP4,    OUTPUT);
            
            digitalWrite(A0, HIGH);
            
            inputString.reserve(100);
  
            Serial.begin(115200);
            Serial.println(F("Home Control - Kit Mini"));
            
            // Start by clearing the Write Protect bit
            // Otherwise the clock data cannot be written
            // The whole register is written,
            // but the WP-bit is the only bit in that register.
            DS1302_write (DS1302_ENABLE, 0);
          
            // Disable Trickle Charger.
            DS1302_write (DS1302_TRICKLE, 0x00);
          
            // Remove the next define,
            // after the right date and time are set.
            //Update_Date_Time( 1, 25, 2015, 1 , 21 , 10, 00 );
            
            lcd.begin(16,2);   // initialize the lcd for 16 chars 2 lines, turn on backlight
          
            // ------- Quick 3 blinks of backlight  -------------
            for(int i = 0; i< 3; i++)
            {
              lcd.backlight();
              delay(250);
              lcd.noBacklight();
              delay(250);
            }
            lcd.backlight(); // finish with backlight on  
          
          //-------- Write characters on the display ------------------
          // NOTE: Cursor Position: (CHAR, LINE) start at 0  
            lcd.setCursor(0,0); //Start at character 4 on line 0
            lcd.print("HomeControl Mini");
            delay(1000);
            lcd.setCursor(0,1);
            lcd.print("   By OpenFog   "); 
            delay(1000); 
            
//            digitalWrite(OP1, HIGH);
//            delay(1000);
//            digitalWrite(OP1, LOW);
//            delay(1000);
//            digitalWrite(OP2, HIGH);
//            delay(1000);
//            digitalWrite(OP2, LOW);

             lcd.setCursor(0,1);
             lcd.print("RY1 OFF, RY2 OFF"); 

}

void loop()
{
  // put your main code here, to run repeatedly:
            ds1302_struct rtc;
            
            if( Timer_Display++ > 10000 ){
              
                      Timer_Display = 0;
                      // Read all clock data at once (burst mode).
                      
                      DS1302_clock_burst_read( (uint8_t *) &rtc);
  
                      lcd.setCursor(0, 0);
                      // print the number of seconds since reset:
                      lcd.print("Time ");
                      lcd.print(bcd2bin( rtc.h24.Hour10, rtc.h24.Hour));
                      lcd.print(":");
                      lcd.print(bcd2bin( rtc.Minutes10, rtc.Minutes));
                      lcd.print(":");
                      lcd.print(bcd2bin( rtc.Seconds10, rtc.Seconds));
                      lcd.print("      ");
                      
                      cpmhour = bcd2bin( rtc.h24.Hour10, rtc.h24.Hour);
                      cpmmin  = bcd2bin( rtc.Minutes10, rtc.Minutes);
                      cpmsec   = bcd2bin( rtc.Seconds10, rtc.Seconds);
                      
//                      cnt++;
//                      if(cnt > 5)
//                       {
//                          cnt = 0;
//                          Serial.print("Time = ");
//                          Serial.print(cpmhour);
//                          Serial.print(":");
//                          Serial.print(cpmmin); 
//                          Serial.print(":");
//                          Serial.println(cpmsec); 
//                       }
  
            }
            
            if (stringComplete) {
                //Serial.println(inputString);
                
                XPORT_Receive(RecieveString);
                
                for(int i = 0; i< 50; i++)
                {
                  RecieveString[i] = 0xFF;
                }
  
                // clear the string:
                inputString = "";
                stringComplete = false;
            }
            
            Check_Timer();
  
}

/*
  SerialEvent occurs whenever a new data comes in the
 hardware serial RX.  This routine is run between each
 time loop() runs, so using delay inside loop can delay
 response.  Multiple bytes of data may be available.
 */
void serialEvent() {
  while (Serial.available()) {
    // get the new byte:
    char inChar = (char)Serial.read();
    if(inChar == '$')
    {
      counter_read = 0;
      RecieveString[counter_read] = '$';
    }
    RecieveString[counter_read] = inChar;
    counter_read++;
    
    // add it to the inputString:
    inputString += inChar;
    // if the incoming character is a newline, set a flag
    // so the main loop can do something about it:
    if (inChar == '*') {
      stringComplete = true;
    }
  }
}
